
HyperScore V5.2 Q&A Sheet -- April, 1989 (revised September, 1991)

What is the HyperScore ToolKit?

The HyperScore ToolKit--developed since 1984--consists of three components.
First, it is a Smalltalk-80 framework for music representation and processing that includes a simple framework for describing and manipulating musical events and structures.  This can be thought of in procedural terms as a set of header files and function libraries for music representation parsers.
Secondly, it is a toolkit of user interface components for constructing interactive music applications, such as score editors or teaching tools.  This is equivalent to a set of  user interface "widgets".
Third, the toolkit includes several different schemes for managing real-time input/output and scheduling event performance that allow the system to be used as an interactive performance instrument.  These are a set of turn-key applications that are however open to customization and enhancement.

The ToolKit is written in the Smalltalk-80 language and adds over 50 new classes to the Smalltalk-80 programming system.  The source code is about 600 KB in size.
The basic classes include abstract music magnitude classes such as Pitch, Duration and Amplitude; and general-purpose event representation classes such as MusicEvent, NoteEvent and EventList.
Many subclasses of these exist for specific types of event modifiers (Crescendo, Rubato) or event generators (Chord, Ostinato, BellPeal).

Who are the intended users?

The HyperScore ToolKit is intended for musicians or music researchers who are interested in building their own music description languages, representations or real-time, interactive graphical applications.
It is a Smalltalk-80 framework and set of components and is aimed at the Smalltalk-80 programmer.
Several built-in applications and on-line demonstrations are included for getting started with little or no knowledge of Smalltalk-80 programming, and the border between customizable applications and application frameworks becomes blurred.

What are typical applications?/Who's using it now?

Over the years, HyperScore users have implemented everything from chord analysis expert systems to real-time sequencers, performance instruments or score editors.
The users and developers of Smalltalk-80 music applications using the HyperScore ToolKit are as widely-dispersed as Stanford University, the University of Illinois, the IRCAM studio in Paris, Yale University, Yamaha, the University of Washington, the University of Stuttgart, Apple, and Fuji/Xerox.

What pictures do you have to show me?

See attached pictures.

What platforms does it run on?

Because it is written in Smalltalk-80, the HyperScore ToolKit is portable to a wide range of platforms.
It has been used on Sun, Apple, Atari, Tektronix, Cadmus, Ardent, IBM and other platforms.
The (optional) special real-time scheduling primitives are implemented for Sun, Apple and Atari platforms.  They are included with the basic distribution.

How do I get it?

(1) Download it via 'anonymous ftp' from "CCRMA.Stanford.edu", directory "pub/st80/hstk5.2".
	The files are:
		hstk5.2.tar.Z -- 'compressed tar' file for UNIX machines
		hatk5.2.sit -- Mac-compatible 'StuffIt' file

(2) Contact the HyperScore Users' Group.
	HUG can be reached at:
		HyperScore User's Group
		P.O. Box 60632
		Palo Alto, California 94306	 USA
		EMail: stp@CCRMA.Stanford.edu

The distribution fileset (which includes all source code, build scripts, documentation and demonstration files), costs $50 for Mac diskette media (please specify which), or Sun 'tar' format streamer tape distribution.

What further publications are available?

	"The Development of an Intelligent Composer's Assistant." Stephen T. Pope. Proceedings of the 1986 International Computer Music Conference. San Francisco: Computer Music Association

	"A Smalltalk-80 Music Toolkit." Stephen T. Pope. Proceedings of the 1987 International Computer Music Conference. San Francisco: Computer Music Association

	"HyperScore Tools for Composers." Computer Music Association 'Array.' Winter, 1987. San Francisco: Computer Music Association

	"The HyperScore ToolKit and Smalltalk-80 Music Applications." Stephen T. Pope. Journal of Object-Oriented Programming, Volume 1 Number 1. SIGS Publications

	Computer Music Journal Special Object-Oriented Programming Issue Volume 13 Number 2, Summer, 1989-forthcoming. MIT Press

	HUG Tech Notes (available from HUG)
		1 - HSTK Description and Example Doc
		2 - HSTK Demo Script
		3 - Notes on Scheduling and Real-time I/O


(Addendum, Sept. 1991: Publications since April, 1989)

	Composition by Refinement. Proceedings of the VIII AIMI Colloquiuo di Informatica Musicale, Cagliari, Sardinia, June, 1989, 10 pages

	Modeling Musical Structures as EventGenerators. Proceedings of the 1989 International Computer Music Conference, Columbus Ohio, June, 1989, 4 pages

	Considerations in the Design of a Music Representation Language. Proceedings of the 1989 International Computer Music Conference, Columbus 
Ohio, June, 1989, 3 pages

	Music Composition and Scoring by Computer. (Invited chapter in a book on computer applications and the humanities, G. Haus, ed.). A-R Editions, 1990, 34 pages.

	Music Representation, Compositional Methodologies, and Computers. Proceedings of the Second Symposium on Music and the Sciences, University of Washington, 
February, 1991, 17 pages

	An Introduction to the MODE: The Musical Object Development Environment. in S. T. Pope, ed. The Well-Tempered Object: Musical Applications of Object-Oriented Software Technology. MIT Press, 1991

	Object-Oriented Design Elements in the MODE: the Musical Object Development Environment. Submitted to Journal of Object-Oriented Programming, April, 1991, 14 pages

	Real-Time Performance via User Interfaces to Musical Structures. Proceedings of the International Workshop in Man-Machine Interaction in Live Performance, Pisa, Italy, June, 1991, 10 pages.

	A Tool for Manipulating Expressive and Structural Hierarchies in Music (or: T-R Trees in the MODE: A Tree Editor Based Loosely on Fred's Theory). Proceedings of the 1991 International Computer Music Conference, Montreal, Quebec, Canada,  4 pages.

---------------------------------------------------------------

SPARCstation/HyperScore Press Release

San Francisco, CA - April 12, 1989

Applying empowering technologies to music leads to ParcPlace Systems appearance in the inner circle of demonstrations at "new world" announcement of Sun's new platforms where Smalltalk-80 music applications are shown live.

The demonstration of sophisticated music software at the announcement of the new Sun machines is due largely due to the portability of Smalltalk-80 applications between platforms.

The HyperScore ToolKit ported to new Sun platform in 1 day, allowing real-time music performance with new high-performance SPARCstations.
The special driver code for real-time interaction on the SPARCstations is now intergrated into the HyperScore ToolKit release.

The entry of workstation-class machines (such as the SPARCstation) into application areas previously reserved for personal micro-computers (such as Macintoshs) is an important step for the users, in this case professional musicians. 

The HyperScore ToolKit--developed since 1984 by Stephen Travis Pope--consists of three components.
First, it is a Smalltalk-80 framework for music representation and processing that includes a simple framework for describing and manipulating musical events and structures.  This can be thought of in procedural terms as a set of header files and function libraries for music representation parsers.
Secondly, it is a toolkit of user interface components for constructing interactive music applications, such as score editors or teaching tools.  This is equivalent to a set of  user interface "widgets".
Third, the toolkit includes several different schemes for managing real-time input/output and scheduling event performance that allow the system to be used as an interactive performance instrument.  These are a set of turn-key applications that are however open to customization and enhancement.

The ToolKit is written in the Smalltalk-80 language and adds over 50 new classes to the Smalltalk-80 programming system.  The source code is about 600 KB in size.
The basic classes include abstract music magnitude classes such as Pitch, Duration and Amplitude; and general-purpose event representation classes such as MusicEvent, NoteEvent and EventList.
Many subclasses of these exist for specific types of event modifiers (Crescendo, Rubato) or event generators (Chord, Ostinato, BellPeal).

The HyperScore ToolKit is intended for musicians or music researchers who are interested in building their own music description languages, representations or real-time, interactive graphical applications.
It is a Smalltalk-80 framework and set of components and is aimed at the Smalltalk-80 programmer.
Several built-in applications and on-line demonstrations are included for getting started with little or no knowledge of Smalltalk-80 programming, and the border between customizable applications and application frameworks becomes blurred.

The HyperScore ToolKit is distributed by the HyperScore Users' Group (HUG) for a small media fee.
There is also a regular newsletter and updates available from HUG
