/**************************************************************************************

					LowlevelMidi

	These routines are just simple wrappers around the Macintosh Trap calls:
		PBOpen, PBClose, PBRead, PBWrite, PBStatus, PBControl.
	See Inside Macintosh II-184 through II-187, for details.
	Adapted from Lee Boynton's code.
	7-11-88, g.e. garnett
	
**************************************************************************************/
	
#include <Devices.h>
#include <Files.h>
#include <Strings.h>

DriverOpen(pb,name)
	IOParam *pb;
	char *name;
{
	pb->ioCompletion = 0L;
	pb->ioNamePtr = c2pstr(name);
 	pb->ioPermssn = 3; /* is 7 in Midi.Lisp midi-open() function, else 3 */
	PBOpen(pb,0);
	return(pb->ioResult);
}

DriverClose(pb)
	IOParam *pb;
{
	return(PBClose(pb,0));
}

DriverRead(pb,ptr,count)
	IOParam *pb;
	Ptr ptr;
	long count;
{
	pb->ioBuffer = ptr;
	pb->ioReqCount = count;
	return(PBRead(pb,0));
}

DriverWrite(pb,ptr,count)
	IOParam *pb;
	Ptr ptr;
	long count;
{
	pb->ioBuffer = ptr;
	pb->ioReqCount = count;
	return(PBWrite(pb,0));
}
/* DriverStatus(pb,csCode,csParam)
	IOParam *pb;
	short csCode;
	int csParam[];
{
	short i,err;
	CntrlParam c;
	c.ioCompletion = 0L;
	c.ioVRefNum = pb->ioVRefNum;
	c.ioCRefNum = pb->ioRefNum;
	c.csCode = csCode;
	err=PBStatus(&c,0);
	for(i=0;i<11;i++)
		csParam[i]=c.csParam[i];
	return(err);
}*/
DriverStatus(pb,csCode,csParam)
	CntrlParam *pb;
	short csCode;
	long *csParam;
{
	short err;

	pb->ioCompletion = 0L;
	pb->csCode = csCode;
	err=PBStatus(pb,0);
/*	printf("In status, cs1 %d, cs2 %d\n",pb->csParam[0],pb->csParam[1]);*/
	*csParam = *((long *)pb->csParam);
/*	csParam[1]=pb->csParam[1];*/
	return(err);
}

DriverControl(pb,csCode,csParam)
	CntrlParam *pb;
	short csCode;
	long *csParam;
{
	pb->ioCompletion = 0L;
	pb->csCode = csCode;
/*	pb->csParam[0] = csParam[0];
	pb->csParam[1] = csParam[1];*/
	*(pb->csParam) = *csParam;
	return(PBControl(pb,0));
}
