/*
 *
 * Interface to Lee Boynton's MIDI driver
 *
 */
#define NIL 0L

#define RAW_EVENT 0
#define NORMAL_EVENT 1
#define NULL_EVENT 2

#define CLOCKTIME_CODE 0
#define KILL_CODE 1
#define RECEIVE_ON 2
#define RECEIVE_OFF 3

#define CLOCK_TICK_SIZE 1L   /* in milliseconds */

#define MIDI_FIFO_SIZE 1024

#define MIDI_NoteOffType 0x80
#define MIDI_NoteOnType 0x90
#define MIDI_PolyTouchType 0xa0
#define MIDI_ControlType 0xb0
#define MIDI_ProgramType 0xc0
#define MIDI_AfterTouchType 0xd0
#define MIDI_PitchBendType 0xe0
#define MIDI_SysRealTimeType 0xf0

#define MIDI_SysXType 0xf0
#define MIDI_SongPosType 0xf2
#define MIDI_SongSelType 0xf3
#define MIDI_TuneType 0xf6
#define MIDI_EndSysXType 0xf7
#define MIDI_ClockType 0xf8
#define MIDI_StartType 0xfa
#define MIDI_ContType 0xfb
#define MIDI_StopType 0xfc
#define MIDI_ActiveSenseType 0xfe
#define MIDI_ResetType 0xff

typedef struct {
	long time;
	unsigned char type,status,data1,data2;
} MIDI_Event, *MIDI_EventPtr;

 typedef struct {
	long clockTime;
	short extra[8];
} MIDI_Parameters, *MIDI_ParametersPtr;

/*typedef struct {
	long clockTime;
} MIDI_Parameters, *MIDI_ParametersPtr;
*/


/*  parameter block for i/o calls  */
/* typedef struct {
	QElemPtr	qLink;
	int			qType;
	int			ioTrap;
	Ptr			ioCmdAddr;
	ProcPtr		ioCompletion;
	OsErr		ioResult;
	StringPtr	ioNamePtr;
	int			ioVRefNum;
	int			ioRefNum;
	int			ioPermssn;
	Ptr			ioMisc,ioBuffer;
	long		ioReqCount,ioActCount;
	int			ioPosMode;
	long		ioPosOffset;
} ioParam;
*/

