'From Smalltalk-80, Version 2.3a of Feburary 5, 1988 on 12 March 1988 at 4:22:21 pm'!

DisplayMedium subclass: #Form
	instanceVariableNames: 'bits width height offset '
	classVariableNames: 'FormConstants BitTableHigh BitTableLow OneBitForm  '
	poolDictionaries: ''
	category: 'Graphics-Display Objects'!


!Form class methodsFor: 'constant access'!

constantDictionary
	"Return my Form constant dictionary."
	"Form constantDictionary"

	^FormConstants!

constantNamed: aSymbol
	"Return a form named aSymbol or nil if not found."

	^self constantNamed: aSymbol ifAbsent: [nil]!

constantNamed: aSymbol ifAbsent: aBlock
	"Return the form named aSmbol or evaluate aBlock."

	^FormConstants at: aSymbol ifAbsent: aBlock!

constantNamed: aSymbol put: aForm
	"Put aForm under the name aSymbol in my constant dictionary"

	^FormConstants at: aSymbol put: aForm!

constantsFromFile: fileName 
	"Load my constant dictionary with the contents of the file named fileName."

	| stream |
	stream _ (FileStream oldFileNamed: fileName) readOnly.
	FormConstants _ Dictionary readFrom: stream.
	stream close!

constantsToFile: fileName 
	"Store the icons in my constant dictionary to the file named fileName."

	| stream |
	stream _ FileStream newFileNamed: fileName.
	FormConstants storeOn: stream.
	stream close! !

!OpaqueForm class methodsFor: 'instance creation'!

extent: extentPoint
	"answer a white OpaqueForm"

	^self new setFigure: (Form extent: extentPoint) 
		shape: (Form extent: extentPoint)! !


!Form class methodsFor: 'music constants'!

initAltoClef
	"initialize a form of a treble clef"
	"Form initAltoClef"
	"(Form constantNamed: #altoClef) displayOn: Display at: 50@50"

	Form constantNamed: #altoClef put: (Form
	extent: 32@32
	fromArray: #( 0 0 0 0 0 0 3328 0 3328 0 3340 0 3358 0 3379 0 3449 32768 3449 49152 3377 49152 3329 49152 3329 49152 3345 49152 3353 32768 3383 0 3447 0 3383 0 3353 32768 3345 49152 3329 49152 3329 49152 3377 49152 3449 49152 3449 32768 3379 0 3358 0 3340 0 3328 0 3328 0 0 0 0 0)
	offset: 0@0)!

initBassClef
	"initialize a form of a treble clef"
	"Form initBassClef"
	"(Form constantNamed: #bassClef) displayOn: Display at: 50@50"

	Form constantNamed: #bassClef put: (Form
	extent: 32@32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 248 0 508 0 526 24576 1551 24576 1927 0 1927 0 1927 0 775 24576 7 24576 7 0 6 0 14 0 12 0 24 0 48 0 224 0 384 0 1792 0 3072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)!

initDoubleFlat
	"generate a form of a rest"
	"Form initDoubleFlat"
	"(Form constantNamed: #doubleFlat) displayAt: 50@50"

	Form constantNamed: #doubleFlat put: (Form
	extent: 16@16
	fromArray: #( 0 0 2304 2304 2304 2304 2304 2880 4064 2912 2912 2880 3456 2304 0 0)
	offset: 0@0)!

initDoubleSharp
	"generate a form of a rest"
	"Form initDoubleSharp"
	"(Form constantNamed: #doubleSharp) displayAt: 50@50"

	Form constantNamed: #doubleSharp put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 1728 1728 256 1728 1728 0 0 0 0 0 0)
	offset: 0@0)!

initEighthNote
	"initialize a form of a treble clef"
	"Form initEighthNote"
	"(Form constantNamed: #eighthNote) displayOn: Display at: 50@50"

	Form constantNamed: #eighthNote put: (Form
	extent: 16@20
	fromArray: #( 0 256 384 384 448 352 304 272 264 264 264 264 264 264 7952 16128 16128 16128 7680 0)
	offset: 0@0)!

initEighthRest
	"generate a form of a rest"
	"Form initEighthRest"
	"(Form constantNamed: #eighthRest) displayAt: 50@50"

	Form constantNamed: #eighthRest put: (Form
		extent: 16@16
		fromArray: #( 0 0 0 0 0 1536 1584 480 32 64 64 64 128 128 128 0)
		offset: 0@0)!

initFlat
	"initialize a form of a treble clef"
	"Form initFlat"
	"(Form constantNamed: #flat) displayOn: Display at: 50@50"

	Form constantNamed: #flat put: (Form
	extent: 16@16
	fromArray: #( 512 512 512 512 512 512 736 816 560 560 560 608 704 768 512 0)
	offset: 0@0)!

initHalfNote
	"initialize a form of a treble clef"
	"Form initHalfNote"
	"(Form constantNamed: #halfNote) displayOn: Display at: 50@50"

	Form constantNamed: #halfNote put: (Form
	extent: 16@20
	fromArray: #( 64 64 64 64 64 64 64 64 64 64 64 64 64 1984 3648 3264 2496 1920 0 0)
	offset: 0@0)!

initHalfRest
	"generate a form of a rest"
	"Form initHalfRest"
	"(Form constantNamed: #halfRest) displayAt: 50@50"

	Form constantNamed: #halfRest put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 0 0 2016 2016 4080 0 0 0 0 0 0)
	offset: 0@0)!

initializeMusicConstants
	"create the standard music forms"
	"Form initializeMusicConstants"

	FormConstants == nil ifTrue:
		[ FormConstants _ Dictionary new: 32 ].
	self initAltoClef.
	self initBassClef.
	self initDoubleFlat.
	self initDoubleSharp.
	self initEighthNote.
	self initEighthRest.
	self initFlat.
	self initHalfNote.
	self initHalfRest.
	self initMordent.
	self initNatural.
	self initQuarterNote.
	self initQuarterRest.
	self initRepeat.
	self initRoll.
	self initSharp.
	self initSigne.
	self initSigne2.
	self initSixteenthNote.
	self initSixteenthRest.
	self initThirtySecondNote.
	self initThirtySecondRest.
	self initTrebClef.
	self initTrill.
	self initTrill2.
	self initWholeNote.
	self initWholeRest!

initMordent
	"generate a form of a rest"
	"Form initMordent"
	"(Form constantNamed: #mordent) displayAt: 50@50"

	Form constantNamed: #mordent put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 3616 4880 4496 2272 0 0 0 0 0 0 0)
	offset: 0@0)!

initNatural
	"initialize a form of a treble clef"
	"Form initNatural"
	"(Form constantNamed: #natural) displayOn: Display at: 50@50"

	Form constantNamed: #natural put: (Form
	extent: 16@16
	fromArray: #( 512 512 512 528 624 1008 912 528 528 624 1008 912 528 16 16 16)
	offset: 0@0)!

initQuarterNote
	"initialize a form of a treble clef"
	"Form initQuarterNote"
	"(Form constantNamed: #quarterNote) displayOn: Display at: 50@50"

	Form constantNamed: #quarterNote put: (Form
	extent: 16@20
	fromArray: #( 0 64 64 64 64 64 64 64 64 64 64 64 64 64 1984 4032 4032 4032 1920 0)
	offset: 0@0)!

initQuarterRest
	"generate a form of a rest"
	"Form initQuarterRest"
	"(Form constantNamed: #quarterRest) displayAt: 50@50"

	Form constantNamed: #quarterRest put: (Form
	extent: 16@20
	fromArray: #( 768 256 128 192 192 448 896 1792 1792 1536 512 256 384 1984 1536 1536 768 256 128 128)
	offset: 0@0)!

initRepeat
	"generate a form of a rest"
	"Form initRepeat"
	"(Form constantNamed: #repeat) displayAt: 50@50"

	Form constantNamed: #repeat put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 3120 3168 192 384 768 1536 3168 6240 0 0 0)
	offset: 0@0)!

initRoll
	"generate a form of a rest"
	"Form initRoll"
	"(Form constantNamed: #roll) displayAt: 50@50"

	Form constantNamed: #roll put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 48 448 1536 48 448 1536 48 448 1536 0 0 0 0)
	offset: 0@0)!

initSharp
	"initialize a form of a treble clef"
	"Form initSharp"
	"(Form constantNamed: #sharp) displayOn: Display at: 50@50"

	Form constantNamed: #sharp put: (Form
	extent: 16@16
	fromArray: #( 128 128 2176 2240 3008 3968 7808 6272 2240 3008 3968 7808 6272 2176 2048 2048)
	offset: 0@0)!

initSigne
	"generate a form of a rest"
	"Form initSigne"
	"(Form constantNamed: #signe) displayAt: 50@50"

	Form constantNamed: #signe put: (Form
	extent: 16@16
	fromArray: #( 0 1536 2312 2064 3104 1600 912 2496 608 1072 2064 4240 96 0 0 0)
	offset: 0@0)!

initSigne2
	"generate a form of a rest"
	"Form initSigne2"
	"(Form constantNamed: #signe2) displayAt: 50@50"

	Form constantNamed: #signe2 put: (Form
	extent: 16@16
	fromArray: #( 0 0 256 256 896 1344 3424 3424 16376 3424 3424 1344 896 256 256 0)
	offset: 0@0)!

initSixteenthNote
	"initialize a form of a treble clef"
	"Form initSixteenthNote"
	"(Form constantNamed: #sixteenthNote) displayOn: Display at: 50@50"

	Form constantNamed: #sixteenthNote put: (Form
	extent: 16@20
	fromArray: #( 512 768 768 896 704 864 928 720 624 560 528 528 528 15904 32256 32256 32256 15360 0 0)
	offset: 0@0)!

initSixteenthRest
	"generate a form of a rest"
	"Form initSixteenthRest"
	"(Form constantNamed: #sixteenthRest) displayAt: 50@50"

	Form constantNamed: #sixteenthRest put: (Form
	extent: 16@16
	fromArray: #( 0 1536 1584 480 32 32 3136 3136 960 128 128 128 256 256 256 0)
	offset: 0@0)!

initThirtySecondNote
	"initialize a form of a treble clef"
	"Form initThirtySecondNote"
	"(Form constantNamed: #thirtySecondNote) displayOn: Display at: 50@50"

	Form constantNamed: #thirtySecondNote put: (Form
	extent: 16@20
	fromArray: #( 512 768 768 896 704 864 928 720 880 944 720 624 560 15888 32272 32288 32256 15360 0 0)
	offset: 0@0)!

initThirtySecondRest
	"generate a form of a rest"
	"Form initThirtySecondRest"
	"(Form constantNamed: #thirtySecondRest) displayAt: 50@50"

	Form constantNamed: #thirtySecondRest put: (Form
	extent: 16@16
	fromArray: #( 3072 3168 896 128 6272 6272 1792 256 12544 12544 3584 512 512 512 1024 1024)
	offset: 0@0)!

initTrebClef
	"initialize a form of a treble clef"
	"Form initTrebClef"
	"(Form trebClef) displayOn: Display at: 50@50"

	Form constantNamed: #trebClef put: (Form
	extent: 32@40
	fromArray: #( 0 0 0 0 3 0 7 32768 6 32768 12 32768 12 32768 8 32768 8 32768 9 32768 9 32768 11 32768 15 0 15 0 30 0 28 0 60 0 116 0 116 0 247 32768 231 57344 207 61440 206 30720 202 14336 202 14336 201 14336 97 12288 49 24576 31 49152 1 32768 0 32768 0 32768 0 32768 24 32768 60 32768 60 32768 25 0 14 0 0 0 0 0)
	offset: 0@0)!

initTrill
	"generate a form of a rest"
	"Form initTrill"
	"(Form constantNamed: #trill) displayAt: 50@50"

	Form constantNamed: #trill put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 1092 3816 6000 8736 0 0 0 0 0 0 0)
	offset: 0@0)!

initTrill2
	"generate a form of a rest"
	"Form initTrill2"
	"(Form constantNamed: #trill2) displayAt: 50@50"

	Form constantNamed: #trill2 put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 128 128 1220 3816 6128 8864 128 128 0 0 0 0 0)
	offset: 0@0)!

initWholeNote
	"initialize a form of a treble clef"
	"Form initWholeNote"
	"(Form constantNamed: #wholeNote) displayOn: Display at: 50@50"

	Form constantNamed: #wholeNote put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 0 1920 2496 3264 3648 1920 0 0 0 0 0)
	offset: 0@0)!

initWholeRest
	"generate a form of a rest"
	"Form initWholeRest"
	"(Form constantNamed: #wholeRest) displayAt: 50@50"

	Form constantNamed: #wholeRest put: (Form
	extent: 16@16
	fromArray: #( 0 0 0 0 0 0 0 0 0 4080 2016 2016 0 0 0 0)
	offset: 0@0)! !


!Form class methodsFor: 'button constants'!

initDoIt
	"generate a form of a rest"
	"Form initDoIt"
	"(Form constantNamed: #doIt) displayAt: 50@50"

	Form constantNamed: #doIt put: (Form
	extent: 21@20
	fromArray: #( 0 0 1 0 1 0 3 32768 31 61440 12 24576 4 16384 7 49152 6 49152 12 24576 8 8192 0 0 2048 0 2048 16384 14722 57344 19010 16384 19010 16384 19010 16384 14722 24576 0 0)
	offset: 0@0)!

initializeButtonConstants
	"create the standard button forms"
	"Form initializeButtonConstants"

	FormConstants == nil ifTrue:
		[ FormConstants _ Dictionary new: 32 ].
	self initDoIt.
	self initPrintIt.
	self initInspect.
	self initPlay.!

initInspect
	"generate a form of a rest"
	"Form initInspect"
	"(Form constantNamed: #inspect) displayAt: 50@50"

	Form constantNamed: #inspect put: (Form
	extent: 30@20
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 128 8192 256 16384 1007 32768 528 32768 528 32768 17110 32768 16879 0 0 8 23790 12700 21129 19016 21065 31240 21033 16968 21230 14732 8 0 8 0)
	offset: 0@0)!

initPlay
	"generate a form of a rest"
	"Form initPlay"
	"(Form constantNamed: #play) displayAt: 50@50"

	Form constantNamed: #play put: (Form
	extent: 22@20
	fromArray: #( 0 0 1 0 1 0 1 0 1 0 1 0 1 0 31 0 63 0 63 0 63 0 286 0 256 0 14649 4096 9481 4096 9528 40960 9544 40960 14652 16384 8192 16384 8193 32768)
	offset: 0@0)!

initPrintIt
	"generate a form of a rest"
	"Form initPrintIt"
	"(Form constantNamed: #printIt) displayAt: 50@50"

	Form constantNamed: #printIt put: (Form
	extent: 30@20
	fromArray: #( 0 0 0 0 0 36864 1 8192 2 16384 4 32768 15 7424 10 8960 12 24576 15 32768 63 65408 32 128 0 8208 29358 28856 19241 8336 18985 8336 18985 8336 29225 12440 16384 0 16384 0)
	offset: 0@0)! !

!Icon class methodsFor: 'constant initialization'!

initScore
	"Icon initScore"
	"Icon constantNamed: #score"

	self constantNamed: #score put:
		(Icon form: (OpaqueForm figure: ((Form
	extent: 32@32
	fromArray: #( 0 0 0 0 0 0 0 0 32767 65534 13 32768 1816 49152 3485 32768 32767 65534 3485 32768 3864 50790 3485 32768 32767 65534 3472 0 3863 0 3485 32768 32767 65534 3485 32768 3863 0 2064 0 32767 65534 2064 0 2064 0 2064 0 2064 0 2064 0 2064 0 2064 0 2048 0 0 0 0 0 0 0)
	offset: 0@0)) shape: ((Form
	extent: 32@32
	fromArray: #( 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535 65535)
	offset: 0@0))) textRect: nil)! !

Icon initScore!

