'From Smalltalk-80, Version 2.2 of July 4, 1987 on 5 March 1988 at 2:59:28 pm'!

MouseMenuController subclass: #FormHitController
	instanceVariableNames: 'array grid size '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graphics-Editors'!
FormHitController comment:
'FormHitControllers are simple controllers that use arrays of elements contained in their views to select.
See examples of their usage in the displayInView messages in Form, Cursor and Icon.'!


!FormHitController methodsFor: 'basic control sequence'!

controlInitialize
	super controlInitialize.
	Cursor crossHair show!

controlTerminate
	Cursor normal show! !

!FormHitController methodsFor: 'control defaults'!

isControlActive
	^super isControlActive & sensor blueButtonPressed not!

redButtonActivity 
	| formPoint displayPoint virtualPoint |
	sensor waitNoButton.
	formPoint _ (view inverseDisplayTransform: sensor cursorPoint).
	virtualPoint _ (formPoint x // grid x) @ (formPoint y // grid y).
"	Transcript show: formPoint printString, ' ', virtualPoint printString; cr."
	self select: virtualPoint.! !

!FormHitController methodsFor: 'accessing'!

array: aVal
	array _ aVal!

grid: aPoint
	grid _ aPoint!

size: aVal
	size _ aVal! !

!FormHitController methodsFor: 'selection'!

select: aPoint
	"given a virtual selection point, determine which form has been selected and edit it"

	| index |
	index _ (aPoint x + 1) + (aPoint y * size x).
"	Transcript show: aPoint printString, '   ', index printString; cr.
"	(array at: index) bitEdit.! !