'From Smalltalk-80, version 2.1, of Septemper 24, 1986 on 20 January 1987 at 4:49:11 pm'!

!PositionableStream methodsFor: 'accessing'!

skipTo: anObject
	"skip forward to the occurrence (if any, not inclusive) of anObject.  If not there, answer nil.  Leaves positioned before anObject."

	| element |
	[(element _ self next) == nil or: [element = anObject]]
		whileFalse:
			[ ].
	self atEnd ifTrue: [ ^nil ].
	^self!

skipToAll: aCollection
	"skip forward to the occurrence (if any, not inclusive) of aCollection.  If not there, answer nil.  Leaves positioned before aCollection."

	| nonMatch first length element |
	(length _ aCollection size) = 0 ifTrue: [^nil].
	first _ aCollection at: 1.
	[true] whileTrue:
		[[(element _ self next) == nil or: [element = first]] whileFalse: 
			[ ].
		element == nil ifTrue: [ ^nil ].
		nonMatch _ 2.
		[nonMatch <= length and: [self next = (aCollection at: nonMatch)]]
				whileTrue: [nonMatch _ nonMatch + 1].
		nonMatch > length
			ifTrue: [self skip: length negated.
					^self].							"success"
		self atEnd ifTrue: [^nil].
													"back up"
		self skip: 1 - nonMatch ]!

upThrough: anObject
	"Answer a subcollection from position to the occurrence (if any, inclusive) of anObject.  If not there, answer everything.  Leaves positioned after anObject."

	| newStream element |
	newStream _ WriteStream on: (collection species new: 64).
	[(element _ self next) == nil or: [element = anObject]]
		whileFalse:
			[newStream nextPut: element].
	^newStream contents!

upThroughAll: aCollection
	"Answer a subcollection from position to the occurrence (if any, inclusive) of aCollection.  If not there, answer everything.  Leaves positioned after aCollection."

	| newStream nonMatch first element length|
	(length _ aCollection size) = 0 ifTrue: [^self next: 0].
	first _ aCollection at: 1.
	newStream _ WriteStream on: (collection species new: 64).
	[true] whileTrue:
			[[(element _ self next) == nil or: [element = first]]
				whileFalse: [newStream nextPut: element].
			newStream nextPut: first.   
			self atEnd ifTrue: [^newStream contents].		"answer everything"
			nonMatch _ 2.
			[nonMatch <= length and: [self next = (aCollection at: nonMatch)]]
				whileTrue: [nonMatch _ nonMatch + 1].
			nonMatch > length 
				ifTrue: [newStream nextPutAll: (aCollection copyFrom: 2 to: aCollection size).
						^newStream contents].	"found it"
			self atEnd ifTrue: [nonMatch _ nonMatch - 1].
			self skip: 1 - nonMatch]							"back up"!

upToAll: aCollection
	"Answer a subcollection from position to the occurrence (if any, not inclusive) of aCollection.  If not there, answer everything.  Leaves positioned before aCollection."

	| newStream nonMatch first |
	aCollection isEmpty
		ifTrue:
			[^self next: 0].
	first _ aCollection first.
	newStream _ String new writeStream.
	[true]
		whileTrue:
			[newStream nextPutAll: (self upTo: first).
			self atEnd
				ifTrue:
					[^newStream contents].			"not found, answer everything"
			nonMatch _
				(2 to: aCollection size)				"find first mismatch"
					detect: [:index | self next ~= (aCollection at: index)]
					ifNone: [^newStream contents].	"success"
			newStream nextPut: first.
			self atEnd
				ifTrue:
					[nonMatch _ nonMatch - 1].
			self skip: 1 - nonMatch]					"back up"! !


