'From Smalltalk-80, Version 2.3 of 13 June 1988 on 2 April 1989 at 11:33:22 am'!

Point subclass: #ZPoint
	instanceVariableNames: 'z '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graphics-Primitives'!
ZPoint comment:
'ZPoint is a point with a z-coordinate.
It does not currently implement any Point protocol other than accessing.'!


!ZPoint methodsFor: 'accessing'!

z
	"Answer the z coordinate."

	^z!

z: zInteger 
	"Set the z coordinate."

	z _ zInteger! !

!ZPoint methodsFor: 'printing'!

printOn: aStream 
	"Append to the argument aStream in terms of infix notation."

	super printOn: aStream.
	aStream nextPut: $@.
	z printOn: aStream!

storeOn: aStream
	"Append to the argument aStream a sequence of characters that is an expression whose evaluation creates a point similar to the receiver.  The general format for Zpoints is
		( class-name x: aNumber y: aNumber z: aNumber)"


	aStream nextPut: $(;
	nextPutAll: self species name;
	nextPutAll: ' x: ';
	store: x;
	nextPutAll: ' y: ';
	store: y;
	nextPutAll: ' z: ';
	store: z;
	nextPut: $).! !

!ZPoint methodsFor: 'private'!

setX: xNumber setY: yNumber setZ: zNumber
	"Initialize the instance variables."
	
	x _ xNumber.
	y _ yNumber.
	z _ zNumber! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ZPoint class
	instanceVariableNames: ''!


!ZPoint class methodsFor: 'instance creation'!

x: xInteger y: yInteger z: zInteger
	"Answer a new instance of a Point with coordinates xInteger and yInteger."

	^self new setX: xInteger setY: yInteger setZ: zInteger! !

!Point methodsFor: 'converting'!

@ aZNumber
	"sending the @ selector to a point creates and returns a ZPoint"

	^ZPoint x: x y: y z: aZNumber! !
