'From Smalltalk-80, Version 2.4 of 28 January 1989 on 22 March 1989 at 4:23:21 pm'!



!NoteSelector methodsFor: 'displaying'!

displayView
	
	| number point icons |
	icons _ (MusicConstants at: #StdNoteIcons) values asOrderedCollection.
	number _ icons size.
	point _ self insetDisplayBox origin + (8@12).
	1 to: number do: [ :aNum |
		(icons at: aNum) == nil ifFalse: [
			(icons at: aNum) displayOn: Display at: point 
				clippingBox: self insetDisplayBox rule: Form reverse mask: Form black.
			point _ point + (0@32)]].

	point _ self insetDisplayBox origin + (32@12).
	icons _ (MusicConstants at: #StdRestIcons) values asOrderedCollection.
	number _ icons size.
	1 to: number do: [ :aNum |
		(icons at: aNum) == nil ifFalse: [
			(icons at: aNum) displayOn: Display at: point 
				clippingBox: self insetDisplayBox rule: Form reverse mask: Form black.
			point _ point + (0@32)]].! !

!NoteSelector methodsFor: 'selecting'!

pickIcon: num

	| box |
	box _ (self insetDisplayBox origin + (0@ (24*(num - 1))) 
		extent: insetDisplayBox extent x @ 24).
	Display reverse: box.
	(Delay forMilliseconds: 300) wait.
	Display reverse: box.
	num < 8 ifTrue: [
		eLView instrument: (((MusicConstants at: #StdNoteIcons) values asOrderedCollection) at: num) 
				number: num
	] ifFalse: [
		eLView instrument: (((MusicConstants at: #StdRestIcons) values asOrderedCollection) at: num) 
				number: num
	]! !


!EventListEditorController methodsFor: 'menu messages'!

play
	"play or start/stop the selected EventList"

	sensor leftShiftDown 
		ifTrue: [model startStop]
		ifFalse: [model play].
	self centerCursorInView.! !


!NoteEvent methodsFor: 'printing'!

storeOn: aStream 
	"format and store the source the receiver note"

	aStream nextPutAll: '(NoteEvent'.
	duration == nil ifFalse:
		[ aStream nextPutAll: ' dur: ', duration value storeString ]. 
	pitch == nil ifFalse: 
		[ aStream nextPutAll: ' pitch: ', pitch value storeString ].
	loudness == nil ifFalse: 
		[ aStream nextPutAll: ' ampl: ', loudness value storeString ].
	voice == nil ifFalse: 
		[ aStream nextPutAll: ' voice: ', voice storeString ].
	aStream nextPutAll: ')'! !


!EventList methodsFor: 'accessing'!

play: aNote at: aTime dur: aDur amp: anAmp
	"add the given event to the list--useful for using lists to play generators onto"

	self add: ((self defaultEventClass new) 
				pitch: (Pitch value: aNote); 
				dur: (Duration value: aDur); 
				ampl: (Amplitude value: anAmp))
		at: aTime! !

!EventList methodsFor: 'scheduling'!

playPrimAt: start
	"play NoteEvent data from my instance variables starting at the given time--use the scheduling primitives"
	"(EventList named: #le1) playPrim."

	| time event relOffset |
"	Midi isOpen
			ifFalse: [ Midi openAndInitialize ].
"	relOffset _ Midi getClockTime.
	events do: [ :anAssociation |
		time _ anAssociation key.
		event _ anAssociation value.
		(event isKindOf: EventList)
			ifTrue: [event playPrimAt: time]
			ifFalse: [Midi play: event pitch asMidi
						at: time + start + relOffset
						dur: event duration asMS
						amp: event ampl asMidi
						voice: event voice ]]! !

!EventList methodsFor: 'printing'!

printOn: aStream
	"print out all of my events"

	| anEvent count |
	aStream nextPutAll: '(EventList ', (self name printString), '  dur:	', duration printString, 
			'  events:	', events size printString.
	pitch == nil ifFalse: [ aStream nextPutAll: '	pitch:	', pitch printString ].
	((props ~~ nil) and: [(props at: #tempo ifAbsent: [nil]) ~~ nil])
			ifTrue: [ aStream nextPutAll: '	tempo:	', (props at: #tempo) printString ].
	aStream cr.
	Sensor leftShiftDown 
			ifFalse: [ count _ events size min: 20 ]
			ifTrue: [ count _ events size ].
	1 to: count do: [ :ind |
		anEvent _ events at: ind.
		aStream nextPutAll: anEvent key printString, ' -> '.
		anEvent value printOn: aStream].
	count = events size 
			ifTrue: [aStream nextPut: $); cr ]
			ifFalse: [aStream nextPutAll: ' ... )'; cr ].!

storeOn: aStream
	"print out all of my events"

	| anEvent count |
	aStream nextPutAll: '((EventList  newNamed: ', (self name printString), ')'.
	pitch == nil ifFalse: [aStream nextPutAll: '	pitch: ', pitch printString].
	tempo == nil ifFalse: [pitch == nil ifFalse: [aStream nextPut: $;].
				aStream nextPutAll: ' tempo:	', tempo printString].
	aStream cr.
	count _ events size.
	1 to: count do: [ :ind |
		anEvent _ events at: ind.
		aStream nextPutAll: 'add: (', anEvent key printString, ' => '.
		anEvent value storeOn: aStream.
		aStream nextPut: $).
		ind < count ifTrue: [aStream nextPut: $;; cr]].
	aStream nextPutAll: ')'.!

storeOnFile: aName
	"store out all of my events on the named file"

	| fs |
	fs _ FileStream fileNamed: aName.
	self storeOn: fs.
	fs close.! !

!EventList methodsFor: 'private'!

map: anAssociation
	"map my special properties and/or eventModifiers onto the given event"

	| aTime anE |
	aTime _ anAssociation key.
	anE _ anAssociation value.
	pitch == nil 			"if i'm transposed"
		ifFalse: [ anE pitch: (Pitch value: (anE pitch + pitch)) ].
	loudness == nil 		"or scaled"
		ifFalse: [ anE loudness: (anE loudness + loudness) ].
		(props == nil) 
			ifFalse: [(props at: #tempo ifAbsent: [nil]) == nil		"or have a tempo map"
				ifFalse: [aTime _ aTime * ((props at: #tempo) at: aTime).
					anE duration: anE duration * ((props at: #tempo) at: anE duration)]].
	^anAssociation! !


ThreePartHSEventListView subclass: #CMNEventListView
	instanceVariableNames: 'duration steps '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Music-Editors'!

!CMNEventListView reorganize!
('initialize-release' initialize2 initialize4)
('accessing' instrument:number:)
('interaction' eventAt: trackEvent:inset:)
('displaying' display:selected:)
('transformations' formXFromTime: roundToNote:)
('staves' CMNstaff2 CMNstaff4)
('private' defaultParameters2 defaultParameters4 initForms2 initForms4)
!



!CMNEventListView methodsFor: 'initialize-release'!

initialize2
	"set up the default variables for a 2-staff CMN editor"

	super initialize.
	self defaultParameters2.
	self initForms2.
	self CMNstaff2.			"default 2-system staves"
	self class barLines: form scale: 20.
	icon _ Form constantNamed: #quarterNote.
	instrument _ 1.
	dOffset _ 0@0.
	cachedForm _ form deepCopy.! !

!CMNEventListView methodsFor: 'interaction'!

eventAt: aPoint 
	"take a point and put up the right Event icon there.  
	Return a NoteEvent to the controller who passes it on to the model. "

	| origin displayPoint roundedPoint nDuration association relativePoint |
	origin _ insetDisplayBox origin.
										"point relative to whole form"
	relativePoint _ self relativeCoordinatesFor: (aPoint - origin).
"	Transcript show: ' rP: ', relativePoint printString."
										"rounded display point"
	displayPoint _  (self displayCoordinatesFor: relativePoint) + origin.	
										"show note position"
	icon displayOn: Display at: displayPoint
		clippingBox: insetDisplayBox
		rule: Form paint 
		mask: Form black.
	(Sensor redButtonPressed) 			"now track note duration"
		ifTrue: [ nDuration _ self trackEvent: displayPoint inset: insetDisplayBox ]
		ifFalse: [ nDuration _ 0. ].
	nDuration _ (MusicConstants at: #StdNoteIcons) keyAtValue: icon ifAbsent:
			[(MusicConstants at: #StdRestIcons) keyAtValue: icon ifAbsent: [nil]].
	(nDuration isKindOf: Symbol)
			ifTrue: [nDuration _ Number readFrom: (ReadStream on: nDuration asString)].
	roundedPoint _ self roundToNote: relativePoint.
						"generate a time -> event association for returning to the controller."
	association _ (roundedPoint x) =>
			(model defaultEventClass 
				dur: nDuration
				pitch: roundedPoint y 
				voice: instrument).
	Transcript show: '  ',  association printString.
									"put the note on the form."
"	self display: association selected: false.	  --not necessary if we believe the above scaling works
	self displayView.
"	^association!

trackEvent: pt inset: box
	"track an active event's length while active"

	| newPt oldPt x  xmin     |
	xmin _ pt x.
	x _ 0.
					"track the cursor's x-coordinate as long as the redButton's pressed"
	[Sensor redButtonPressed] whileTrue: 
			[newPt _ Sensor cursorPoint.
			newPt ~= oldPt ifTrue: 
			[x _ (newPt x max: xmin) roundTo: timeGrain.
			oldPt _ newPt]].
	^x - pt x! !

!CMNEventListView methodsFor: 'displaying'!

display: anAss selected: aBool
	"Display an Event in an EventListEditorView"

	| anE displayPoint myBox line voice dur icon |
	anE _ anAss value.
	line _ Line new form: ((Form new) extent: 2@2; black).
	myBox _ form boundingBox.
	displayPoint _ (self formXFromTime: anAss key) @ 
				(self formYFromPitch: anE pitch).
	dur _ anE duration asFraction.
"	icon _ #() at: (#() indexOf: dur ifAbsent: [1])"
"	Transcript show: ' dP: ', displayPoint printString; cr."
	aBool ifTrue: [((MusicConstants at: #HighlightIcons) at: (voice max: 1)) 
			displayOn: form 
			at: displayPoint
			clippingBox: myBox 
			rule: Form paint 
			mask: Form black]
		ifFalse: [((MusicConstants at: #StdNoteIcons) at: (voice max: 1)) 
			displayOn: form 
			at: displayPoint
			clippingBox: myBox 
			rule: Form paint 
			mask: Form black].! !

!CMNEventListView methodsFor: 'transformations'!

formXFromTime: aTime
	"take a note's time and return a display point x coordinate relative to the form."

	^((aTime / timeScale) asInteger - timeOffset) + clefForm width!

roundToNote: aPoint
	"take a rounded view point and justify it to my eventListEditor's note sizes."

	| time pitch |
	time _ aPoint x roundTo: timeGrain.
	pitch _ (aPoint y // pitchScale + pitchOffset) rounded.
	pitch > 36 ifTrue: [ pitch _ pitch + 2 ].
	^((time * timeScale + timeOffset) rounded) @ pitch! !

!CMNEventListView methodsFor: 'private'!

defaultParameters2

	| base |
	base _ 8.				"basic step size in pixels"
	timeOffset _ 0.			"view offset"
	timeScale _ 20.			"ms/pixel"
	timeGrain _ 25.			"min event offset"
	pitchOffset _ 20.		"lowest note"
	pitchScale _ base * 2.	"well tempered"
	pitchGrain _ base / 2.		"spacing between accidentals"
	duration _ 1/4.!

initForms2
	"set up my graphical forms for scrolling around on."

	| formSize clefSize |
	formSize _ 1024@170.
	form _ Form extent: formSize.
	form fill: (0@0 extent: formSize) rule: Form over mask: Form white.
	clefSize _ 32@170.
	clefForm _ Form extent: clefSize.
	clefForm fill: (0@0 extent: clefSize) rule: Form over mask: Form white.
	steps _ #("c-24" 26 30 34 38 42 46 50 54 58 62 66 70 74 78 92 "c-48" 106 102 106 110 114 118 122 126 130 134 138 142 146 150 "c")! !


!EventListDictionaryInspector methodsFor: 'field list'!

fieldMenu
	"EventListDictionaryInspector flushMenus" 

	field == nil ifTrue:
		[^ActionMenu
			labels: 'inspect dictionary\update list' withCRs
			lines: nil
			selectors: #(inspectDict updateList)].
	EvListDictListMenu == nil ifTrue:
		[EvListDictListMenu _ ActionMenu
			labels: 'inspect\references\play\edit\rename\remove' withCRs
			lines: #(2 4)
			selectors: #(inspectField browseReferences
					 play edit renameField removeField)].
	^EvListDictListMenu! !

!EventListDictionaryInspector methodsFor: 'menu items'!

inspectDict
	EventLists inspect! !


!ScreenController methodsFor: 'menu messages'!

openScreenSaver
	"open Glenn's neat random spline screen saver"

	[Sensor keyboardPressed] whileFalse:
			[Spline randomSplineSample].
	Sensor keyboard.
	ScheduledControllers restore! !


!ScreenController class methodsFor: 'class initialization'!

initializePPS
	"Initialize the System Menu for PPS internal HSTK V5.0."
	"ScreenController initializePPS.
	ScreenController allInstancesDo: [:c | c initializeYellowButtonMenu]"

	ScreenYellowButtonMenu _
		PopUpMenu
			labels: 
'restore display
garbage collect
exit project
browser
workspace
file list
file editor
terminal
project
system transcript
system outline
screen saver
suspend
save
quit'
			lines: #(3 9 11 12).
	ScreenYellowButtonMessages _
			#(restoreDisplay garbageCollect exitProject
			openBrowser openWorkspace openFileList openFileEditor openCshView openProject 
			openTranscript openSystemOutline openScreenSaver
			openDeskTop save quit).! !


!EventGenerator methodsFor: 'playing'!

play
	"play me"

	self eventList play
"	self asScore play"! !


EventGenerator class
	instanceVariableNames: ''!


!NoteSelector class methodsFor: 'class initialization'!

initialize
	"NoteSelector initialize."

	| dict |
	dict _ Dictionary new: 6.
	dict at: '1/1' asSymbol put: ((Form constantNamed: #wholeNote) offset: -6@-8).
	dict at: '1/2' asSymbol put: ((Form constantNamed: #halfNote) offset: -6@-16).
	dict at: '1/4' asSymbol put: ((Form constantNamed: #quarterNote) offset: -6@-16).
	dict at: '1/8' asSymbol put: ((Form constantNamed: #eighthNote) offset: -4@-16).
	dict at: '1/16' asSymbol put: ((Form constantNamed: #sixteenthNote) offset: -4@-16).
	dict at: '1/32' asSymbol put: ((Form constantNamed: #thirtySecondNote) offset: -4@-16).
	(Smalltalk at: #MusicConstants) at: #StdNoteIcons put: dict.

	dict _ Dictionary new: 6.
	dict at: '1/1' asSymbol put: ((Form constantNamed: #wholeRest) offset: -7@-9).
	dict at: '1/2' asSymbol put: ((Form constantNamed: #halfRest) offset: -6@-9).
	dict at: '1/4' asSymbol put: ((Form constantNamed: #quarterRest) offset: -6@-9).
	dict at: '1/8' asSymbol put: ((Form constantNamed: #eighthRest) offset: -7@-8).
	dict at: '1/16' asSymbol put: ((Form constantNamed: #sixteenthRest) offset: -7@-8).
	dict at: '1/32' asSymbol put: ((Form constantNamed: #thirtySecondRest) offset: -7@-8).
	(Smalltalk at: #MusicConstants) at: #StdRestIcons put: dict.! !
NoteSelector initialize!


!Ostinato methodsFor: 'playing'!

play
	"use the prims by default"

	self playPrimAt: Time millisecondClockValue!

play: numberOfTimes
	"return an event list from the given number of times playing"

	| time pattern |
	time _ 0.
	pattern _ EventList newAnonymous.
	numberOfTimes timesRepeat:
		[pattern add: self events at: time.
		time _ time + self duration ].
	pattern play!

playOn: aVoice at: firstTime
	"play an ostinato until turned off."

	| startTime realTime | 
	startTime _ firstTime.
	playing _ true.
	process _ [[playing] whileTrue: 
			[list playOn: aVoice at: startTime.
			startTime _ startTime + list duration.
			(Delay untilMilliseconds: startTime - 500) wait]] forkAt: 5!

playPrimAt: firstTime
	"play an ostinato until turned off."

	| startTime | 
	startTime _ firstTime.
	playing _ true.
	process _ [[playing] whileTrue: 
			[list playPrimAt: startTime.
			startTime _ startTime + list duration.
			(Delay untilMilliseconds: startTime - 500) wait.
		Transcript show: 'x '. ]] forkAt: 5! !

Roll class
	instanceVariableNames: ''!

Cluster class
	instanceVariableNames: ''!

CMNEventListView class
	instanceVariableNames: ''!


!CMNEventListView class methodsFor: 'instance creation'!

open2StaffOnc: anEL
	"Open a view for a new eventListEditor without scrollBars"
	"CMNEventListView open2StaffOnc: (EventListEditor defaultEL)"

	| eventList topView eventListEditor eventListView eventListEditorController instSelV|

	eventList _ anEL.		"given event list"
	eventListEditor _ EventListEditor new.
	eventListEditor list: eventList.	"set me up"

	eventListEditorController _ EventListEditorController new
		model: eventListEditor.
	eventListView _ self new initialize2;
		controller: eventListEditorController;
		model: eventListEditor.
	topView _ StandardSystemView new
		label: 'Simple CMN Event List Editor';
		minimumSize: 500@170; maximumSize: 1024@170;
		borderWidth: 2;
		insideColor: Form darkGray.
	instSelV _  InstrumentSelector new
"		borderWidth: 2;"
		insideColor: Form white;
		eLView: eventListView.
	topView addSubView: eventListView in: (0.15@0.05 extent: 0.8@0.9) borderWidth: 1.
	topView addSubView: instSelV in: (0.954@0.05 extent: 0.04@0.9) borderWidth:1.
	topView controller open.!

open2StaffOnd: anEL
	"Open a view for a new eventListEditor without scrollBars"
	"CMNEventListView open2StaffOnd: (EventListEditor defaultEL)"

	| eventList topView eventListEditor eventListView eventListEditorController |
	eventList _ anEL.				"given event list"
	eventListEditor _ EventListEditor new.
	eventListEditor list: eventList.	"set me up"

	topView _ StandardSystemView new
		label: 'CMN Event List Editor';
		minimumSize: 500@200; 
		maximumSize: 1024@200;
		borderWidth: 2;
		insideColor: Form gray.

	eventListEditorController _ EventListEditorController new
		model: eventListEditor.
	eventListView _ self new initialize2;
		controller: eventListEditorController;
		model: eventListEditor.
	self make8ButtonRowOn: eventListView 
			within: topView 
			rect: (0.01@0.02 extent: 0.03@0.96).
	topView addSubView: (self makeAmpGaugeViewOn: eventListView) 
			in: (0.045@0.02 extent: 0.06@0.96) 
			borderWidth: 0;
		addSubView: eventListView 
			in: (0.12@0.07 extent: 0.77@0.8) 
			borderWidth: 1;
		addSubView: (self addHorizontalScrollBarOn: eventListView) 
			in: (0.12@0.88 extent: 0.77@0.07) 
			borderWidth: 0;
		addSubView: (NoteSelector new insideColor: Form white; eLView: eventListView) 
			in: (0.9@0.02 extent: 0.08@0.96) 
			borderWidth:1.
	topView controller open.! !


!Cloud methodsFor: 'playing'!

eventList
	"make the cloud's events"
	"assume that the receiver's pitch, loudness and durations are actually intervals"

	| pattern rand number length start |
	pattern _ EventList new.
	rand _ Random new.
	number _ duration asFloat * density.
	length _ (1000 / density) rounded.
	start _ 0.
	number truncated timesRepeat:
		[ pattern add: (NoteEvent 
			dur: (length * 2 "+ (2000 * rand next) rounded")
			pitch: ((pitch first) + 
					((rand next * (pitch last - pitch first)) rounded))
			ampl: ((loudness first) + 
					((rand next * (loudness last - loudness first)) rounded))
			voice: ((voice == nil 
						ifTrue: [nil] 
						ifFalse: [(voice first) + 
					((rand next * (voice last - voice first)) rounded)])))
			at: start.
		start _ start + length].
	^pattern! !


Object subclass: #EventListEditor
	instanceVariableNames: 'list ostinato selection ampl '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Music-Editors'!

!EventListEditor reorganize!
('initialize-release' initialize)
('accessing' ampl ampl: decrementampl defaultEventClass incrementampl list list: selection)
('list access' add: eraseList inspectList play remove: startStop)
('links and groups' link:with: select:)
!



!EventListEditor methodsFor: 'list access'!

startStop
	"if not playing, create ostinato and start; if playing, stop and release."

	ostinato == nil
		ifTrue: [ostinato _ Ostinato onList: list.
				[ostinato play] fork]
		ifFalse: [ostinato stop.
				ostinato _ nil]! !

EventListEditor removeSelector: #at:!
EventListEditor removeSelector: #at:put:!
EventListEditor removeSelector: #doesNotUnderstand:!


!EventListView methodsFor: 'scrolling'!

offsetX: newX
	"set the y value of my offset if newX is a legal value"

	((dOffset x - self insetDisplayBox extent x) >= (form extent x negated) 
					and: [dOffset x <= 0])
		ifTrue:
			[ dOffset x: newX truncated.
			self changed: #offsetX.
			self displayView.
"			Transcript show: newX asInteger printString, ' '.
			Sensor leftShiftDown ifTrue: [self halt]"
			]!

offsetY: newY
	"set the y value of my offset if newY is a legal value"

	(dOffset y >= (form extent y negated + (self insetDisplayBox extent y)) 
					and: [dOffset y <= 0])
		ifTrue:
			[ dOffset y: newY truncated.
			self changed: #offsetY.
			self displayView ]!

scrollLeft: amount
	"scroll me left by amount."

	(dOffset x - self insetDisplayBox extent x) > (form extent x negated) ifTrue:
		[ dOffset _ dOffset - (amount@0)].
	self changed: #offsetX!

scrollRight: amount
	"scroll me right by amount."

	dOffset x < 0 ifTrue:
		[ dOffset _ dOffset + (amount@0)].
	self changed: #offsetX! !

!EventListView methodsFor: 'displaying'!

redraw
	"used to regenerate view."

	| selections realList |
	Cursor wait showWhile:
		[ self initForm.
		selections _ model selection.
		realList _ model list expandedFrom: timeOffset 
							to: timeScale * form width + timeOffset.
		realList do: 
			[ :anAssoc |
				self display: anAssoc selected: (selections includes: anAssoc) ].
		self displayView ]! !


!InspectorView class methodsFor: 'instance creation'!

viewWithButtons: anInspector in: area of: superView
	"Create proportioned List and Code views on anInspector in area of superView"

	| mid codeView |
	mid _ area left + (area width * 0.3).
	superView addSubView:
		(SelectionInListView
			on: anInspector printItems: anInspector printItems
			oneItem: false aspect: #field change: #field: list: #fieldList
			menu: #fieldMenu initialSelection: #field)
		in: (area copy right: mid; top: area top + 0.1) borderWidth: 1.
	self addListButtonsTo: superView 
			in: (area copy bottom: area top + 0.1; right: mid) 
			for: anInspector.
	codeView _ CodeView on: anInspector aspect: #text
			change: #acceptText:from:
			menu: #textMenu initialSelection: nil.
	superView addSubView: codeView
		in: (area copy left: mid; top: area top + 0.1) borderWidth: 1.
	self addTextButtonsTo: superView 
			in: (area copy bottom: area top + 0.1; left: mid) 
			for: codeView controller.! !


Trill class
	instanceVariableNames: ''!


!SelectionCloud methodsFor: 'playing'!

eventList
	"make the cloud's events"
	"assume that the receiver's pitch, loudness and durations are actually intervals"

	| pattern rand number length start |
	pattern _ EventList new.
	rand _ Random new.
	number _ duration asFloat * density.
	length _ (1000 / density) rounded.
	start _ 0.
	number truncated timesRepeat:
		[ pattern add: (NoteEvent 
			dur: (length * 2 "+ (2000 * rand next) rounded")
			pitch: (pitch atRandom: rand)
			ampl: (loudness atRandom: rand)
			voice: (voice atRandom: rand))
			at: start.
		start _ start + length].
	^pattern! !


Chord class
	instanceVariableNames: ''!
Cloud class
	instanceVariableNames: ''!


EventListView subclass: #HSEventListView
	instanceVariableNames: 'cachedForm '
	classVariableNames: 'Clef Staff '
	poolDictionaries: ''
	category: 'Music-Editors'!


SelectionCloud class
	instanceVariableNames: ''!


!DynamicSelectionCloud methodsFor: 'playing'!

eventList
	"make the dynamic selection cloud's events"
	"assume that the receiver's pitch, loudness and durations are actually 2-D arrays"

	| pattern rand number length start |
	pattern _ EventList new.
	rand _ Random new.
	number _ duration asFloat * density.
	length _ (1000 / density) rounded.
	start _ 0.
	1 to: number do:
		[ :counter |
		pattern add: (NoteEvent 
			dur: (length * 2 "+ (1000 * rand next) rounded")
			pitch: ((rand next > (counter / number)) 
					ifTrue: [ (pitch at: 1) atRandom: rand  ]
					ifFalse: [ (pitch at: 2) atRandom: rand ])
			ampl: (loudness atRandom: rand)
			voice: (voice atRandom: rand))
			at: start.
		start _ start + length].
	^pattern! !


DynamicSelectionCloud class
	instanceVariableNames: ''!

Ostinato class
	instanceVariableNames: ''!

HSEventListView class
	instanceVariableNames: 'Clef Staff '!

DynamicCloud class
	instanceVariableNames: ''!

Arpeggio class
	instanceVariableNames: ''!
